//+------------------------------------------------------------------+
//|                                           Ind_Seasonal+Trade.mq4 |
//|                                 Copyright 2012, Evgeniy Trofimov |
//|                           http://www.mql4.com/ru/users/EvgeTrofi |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012-2013, Evgeniy Trofimov"
#property link      "http://www.mql4.com/ru/users/EvgeTrofi"
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Black
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_color3 LimeGreen
#property indicator_color4 MediumBlue
#property indicator_color5 Coral
#property indicator_color6 SaddleBrown
#property indicator_color7 DeepPink
#property indicator_color8 DarkSlateGray


extern string Formula = "PL-GC=0.03^0.02";    // , : +-=1^1^2
extern int Future = 50;       //   
extern int Past =  50;         //    
extern int BaseSymbol = 0;     //  ,     ( ) 
                               //0 -       
extern bool Compress = true;   //      (   !!!)
extern bool Visual = true;     //    
extern string Interval1 = "5-1";
extern string Interval2 = "10-1";
extern string Interval3 = "15-1";
extern string Interval4 = "20-1";
extern string Interval5 = "25-1";
extern string Interval6 = "";
extern string Interval7 = "";

double Buff_line0[];
double Buff_line1[];
double Buff_line2[];
double Buff_line3[];
double Buff_line4[];
double Buff_line5[];
double Buff_line6[];
double Buff_line7[];

string IndicatorName;
string gSymbol[]; // 
double gVolume[]; //  (  - ,  - )
double gK[];      //  k = TICKVALUE / TICKSIZE
double gLenta[];  //    .  -    !
int IntervalBegin[7], IntervalEnd[7]; //  
int mper[10]={0,1,5,15,30,60,240,1440,10080,43200};
color mcol[7]={Black,Red,LimeGreen,MediumBlue,Coral,SaddleBrown,DeepPink,DarkSlateGray};
datetime DateBeginSpread;  //  
int YearBegin;    //  
bool FirstTime = true; // 
int indexPeriod; //    ( 1  9)
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorBuffers(8);
   if(BaseSymbol==0){
      IndicatorDigits(2);
   }else{
      IndicatorDigits(0);
   }
   IndicatorName="Seasonal Trade "+Formula+"        ";
   IndicatorShortName(IndicatorName);
   int cnt = GlobalInit();
   //Print("  ", cnt, " ");
   for(int i = 0; i < cnt; i++){
      //Print(gSymbol[i], " ", DoubleToStr(gVolume[i], 3));
      gK[i] = MarketInfo(gSymbol[i], MODE_TICKVALUE)/MarketInfo(gSymbol[i], MODE_TICKSIZE);
      //gVolume[i] = gVolume[i] * MarketInfo(gSymbol[i], MODE_TICKVALUE)/MarketInfo(gSymbol[i], MODE_TICKSIZE);
   }
   IntervalInput(1, Interval1);IntervalInput(2, Interval2);IntervalInput(3, Interval3);IntervalInput(4, Interval4);IntervalInput(5, Interval5);IntervalInput(6, Interval6);IntervalInput(7, Interval7);
   LentaInit();
   FirstTime = true;
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0,Buff_line0);
   SetIndexLabel(0, DoubleToStr(Year(),0)); 
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1,Buff_line1);
   SetIndexLabel(1, DoubleToStr(IntervalBegin[0],0)+"-"+DoubleToStr(IntervalEnd[0],0)); 
   SetIndexShift(1, Future);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2,Buff_line2);
   SetIndexLabel(2, DoubleToStr(IntervalBegin[1],0)+"-"+DoubleToStr(IntervalEnd[1],0));
   SetIndexShift(2, Future);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3,Buff_line3);
   SetIndexLabel(3, DoubleToStr(IntervalBegin[2],0)+"-"+DoubleToStr(IntervalEnd[2],0));
   SetIndexShift(3, Future);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexBuffer(4,Buff_line4);
   SetIndexLabel(4, DoubleToStr(IntervalBegin[3],0)+"-"+DoubleToStr(IntervalEnd[3],0));
   SetIndexShift(4, Future);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexBuffer(5,Buff_line5);
   SetIndexLabel(5, DoubleToStr(IntervalBegin[4],0)+"-"+DoubleToStr(IntervalEnd[4],0));
   SetIndexShift(5, Future);
   SetIndexStyle(6, DRAW_LINE);
   SetIndexBuffer(6,Buff_line6);
   SetIndexLabel(6, DoubleToStr(IntervalBegin[5],0)+"-"+DoubleToStr(IntervalEnd[5],0));
   SetIndexShift(6, Future);
   SetIndexStyle(7, DRAW_LINE);
   SetIndexBuffer(7,Buff_line7);
   SetIndexLabel(7, DoubleToStr(IntervalBegin[6],0)+"-"+DoubleToStr(IntervalEnd[6],0));
   SetIndexShift(7, Future);
   return(0);
}//init()
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   for(int y=Year(); y>=YearBegin; y--){
      ObjectDelete("YearLabel"+y);
   }
   VisualJalousieDelete();
   
   return(0);
}//deinit()
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
   int    counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--; 
   int limit=Bars-counted_bars;
   datetime t;
   double spread;
   int i, s;
   double max, min;
   double Profit;
   for (i=0; i<limit; i++) {
      t=Time[i];
      spread=0;
      for(s=0; s<ArraySize(gSymbol); s++){
         Profit = gVolume[s] * gK[s] * GetPrice(gSymbol[s], t, indexPeriod);
         /*if(BaseSymbol>0 && BaseSymbol<=ArraySize(gSymbol) && MarketInfo(gSymbol[s], MODE_PROFITCALCMODE)==0){
            if(MarketInfo(gSymbol[s], MODE_POINT)!=0) Profit = Profit / MarketInfo(gSymbol[s], MODE_POINT);
         }*/
         spread = spread + Profit;
      }//Next s
      if(BaseSymbol>0 && BaseSymbol<=ArraySize(gSymbol)){
         spread = GetTick(gSymbol[BaseSymbol-1], spread, gVolume[BaseSymbol-1],  gK[BaseSymbol-1]);
      }
      Buff_line0[i] = spread;
   }
   VisualCalc();
   if(FirstTime){
      FirstTime=false;
      CreateMiddleSpread(Buff_line1, IntervalBegin[0], IntervalEnd[0]);
      CreateMiddleSpread(Buff_line2, IntervalBegin[1], IntervalEnd[1]);
      CreateMiddleSpread(Buff_line3, IntervalBegin[2], IntervalEnd[2]);
      CreateMiddleSpread(Buff_line4, IntervalBegin[3], IntervalEnd[3]);
      CreateMiddleSpread(Buff_line5, IntervalBegin[4], IntervalEnd[4]);
      CreateMiddleSpread(Buff_line6, IntervalBegin[5], IntervalEnd[5]);
      CreateMiddleSpread(Buff_line7, IntervalBegin[6], IntervalEnd[6]);
      if(Compress){
         Compression(Buff_line0, Buff_line1, Past);
         Compression(Buff_line0, Buff_line2, Past);
         Compression(Buff_line0, Buff_line3, Past);
         Compression(Buff_line0, Buff_line4, Past);
         Compression(Buff_line0, Buff_line5, Past);
         Compression(Buff_line0, Buff_line6, Past);
         Compression(Buff_line0, Buff_line7, Past);
      }
   }
   return(0);
}//start()
//+----------------------------------------------------------------------------+
//|      :   (EvgeTrofi)                                   |
//+----------------------------------------------------------------------------+
//|     : 03.01.2013                                                     |
//|   :                                     |
//+----------------------------------------------------------------------------+
void VisualCalc(){
   if(!Visual) return;
   int hwnd = WindowFind(IndicatorName);
   if (ObjectFind("Date1")==-1) ObjectCreate("Date1",OBJ_VLINE,0,Time[Past-1],0);
   if (ObjectFind("Date2")==-1) ObjectCreate("Date2",OBJ_VLINE,0,Time[0]+3*60*Period(),0);
   datetime BeginTime = MathMin(ObjectGet("Date1", OBJPROP_TIME1), ObjectGet("Date2", OBJPROP_TIME1));
   datetime EndTime   = MathMax(ObjectGet("Date1", OBJPROP_TIME1), ObjectGet("Date2", OBJPROP_TIME1));
   int BeginLenta, EndLenta;
   if(BeginTime<=Time[0]) {
      BeginLenta = Past-1 - iBarShift(Symbol(), Period(), BeginTime);
   }else{
      BeginLenta = Past+ (BeginTime-Time[0])/(Period()*60);
   }
   if(EndTime<=Time[0]) {
      EndLenta = Past-1 - iBarShift(Symbol(), Period(), EndTime);
   }else{
      EndLenta = Past+ (EndTime-Time[0])/(Period()*60);
   }
   string t;
   double Profit;
   int i=0;
   VisualJalousie(Year()-YearBegin+1, 4);
   for(int y=Year(); y>=YearBegin; y--){
      t = "YearLabel"+y;
      if(ObjectFind(t)==-1){
         ObjectCreate(t,OBJ_LABEL,hwnd,0,0);
         ObjectSet(t, OBJPROP_XDISTANCE, 4);
         ObjectSet(t, OBJPROP_YDISTANCE, 15+i*15);
         ObjectSet(t, OBJPROP_COLOR, GetColor(y));
      }
      if(i==0){
         //BeginTime=MathMax(BeginTime, Time[0]);
         //EndTime=MathMax(EndTime, Time[0]);
         Profit = Buff_line0[iBarShift(Symbol(), Period(), EndTime)]-Buff_line0[iBarShift(Symbol(), Period(), BeginTime)];
         ObjectSetText(t, DoubleToStr(Year(),0)+" = "+DoubleToStr(Profit,0),8,"Arial",GetColor(y));
      }else{
         if(TimeYear(Time[Past-1])<Year()){
            Profit = gLenta[EndLenta+(Past+Future)*(y-YearBegin-1)]-
                     gLenta[BeginLenta+(Past+Future)*(y-YearBegin-1)];
         }else{
            Profit = gLenta[EndLenta+(Past+Future)*(y-YearBegin)]-
                     gLenta[BeginLenta+(Past+Future)*(y-YearBegin)];
         }
         ObjectSetText(t, DoubleToStr(y,0)+" = "+DoubleToStr(Profit,0),8,"Arial",GetColor(y));
      }
      i++;
   }//Next y
}//VisualCalc()
//+----------------------------------------------------------------------------+
color GetColor(int inYear){
   if(inYear==Year()) return(mcol[0]);
   for(int i=0; i<7; i++){
      if(inYear>=IntervalBegin[i] && inYear<=IntervalEnd[i]){
         return(mcol[i+1]);
      }
   }
   return(mcol[0]);
}//GetColor()
//+----------------------------------------------------------------------------+
//|      :   (EvgeTrofi)                                   |
//+----------------------------------------------------------------------------+
//|     : 28.12.2012                                                     |
//|   :    A  B                                |
//|    inA -      ( )                    |
//|    outB -     B ()                      |
//|    inCount -     ,            |
//|                B                                            |
//+----------------------------------------------------------------------------+
void Compression(double inA[], double &outB[], int inCount){
   double maxA, minA, maxB, minB;
   inCount = MathMin(MathMin(ArraySize(inA), ArraySize(outB)), inCount);
   maxA = inA[ArrayMaximum(inA, inCount)];
   minA = inA[ArrayMinimum(inA, inCount)];
   maxB = outB[ArrayMaximum(outB, inCount)];
   minB = outB[ArrayMinimum(outB, inCount)];
   for(int i = 0; i<ArraySize(outB); i++){
      if(outB[i]==EMPTY_VALUE) continue;
      outB[i] = (outB[i] - minB) / (maxB - minB) * (maxA - minA) + minA;
   }//Next i
}//Compression()
//+----------------------------------------------------------------------------+
//|      :   (EvgeTrofi)                                   |
//+----------------------------------------------------------------------------+
//|     : 28.12.2012                                                     |
//|   :    .                                    |
//|    inSymbol -                                           |
//|    inProfit -                 |
//|    inLot    -                                            |
//|    inK      -                            |
//+----------------------------------------------------------------------------+
double GetTick(string inSymbol, double inProfit, double inLot = 1, double inK = 0){
   double res=0;
   if(inK==0) inK=MarketInfo(inSymbol, MODE_TICKVALUE)/MarketInfo(inSymbol, MODE_TICKSIZE);
   res = inProfit / (inLot * inK); //  
   res = res / MarketInfo(Symbol(),MODE_TICKSIZE); // -  
   return(res);
}//GetTick()
//+----------------------------------------------------------------------------+
//|      :   (EvgeTrofi)                                   |
//+----------------------------------------------------------------------------+
//|     : 22.12.2012                                                     |
//|   :   outLast,     ,      |
//|               .  -1  .              |
//|    inIntervalB -                                         |
//|    inIntervalE -                                          |
//+----------------------------------------------------------------------------+
int CreateMiddleSpread(double &outLast[], int inIntervalB, int inIntervalE){
   //ArrayResize(outLast, Past+Future);
   ArrayInitialize(outLast, EMPTY_VALUE);
   if(inIntervalB<YearBegin){
      return(-1);
   }
   int i, j, y;
   for(i = 0; i<Past+Future; i++){
      j = Past+Future-i-1;
      outLast[j] = 0;
      for(y = inIntervalB; y <= inIntervalE; y++){
         outLast[j] = outLast[j] + gLenta[i+(Past+Future)*(y-YearBegin)];
      }//Next y
      outLast[j] = outLast[j] / (inIntervalE - inIntervalB + 1);
   }//Next i
   return(0);
}//CreateMiddleSpread()
//+----------------------------------------------------------------------------+
//|      :   (EvgeTrofi)                                   |
//+----------------------------------------------------------------------------+
//|     : 28.12.2012                                                     |
//|   :   gLenta.   .          |
//+----------------------------------------------------------------------------+
int LentaInit(){
   //  
   int Total=0;
   DateBeginSpread=0;
   int Candle=0;
   datetime FirstTime = 0;
   string minSymbol="";
   indexPeriod = GetNumberTimeFrame(Period());
   for(int i=0; i<ArraySize(gSymbol); i++){
      //Candle = iBars(gSymbol[i], PERIOD_MN1);
      FirstTime = (gSymbol[i], indexPeriod);
      if(FirstTime>DateBeginSpread) {
         DateBeginSpread = FirstTime;
         minSymbol = gSymbol[i];
      }
   }
   //    :
   FirstTime = DateBeginSpread + 60 * PERIOD_D1 * (5 - TimeDayOfWeek(DateBeginSpread));
   if(FirstTime < DateBeginSpread) DateBeginSpread = DateBeginSpread + 60 * PERIOD_D1 * 7;
   YearBegin = TimeYear(DateBeginSpread);
   if(TimeDayOfYear(DateBeginSpread) > TimeDayOfYear(Time[Past])) YearBegin++;
   Print(" : "+YearBegin,",  : ", TimeToStr(DateBeginSpread),"    ", minSymbol);
   
   //  
   int YearLeft = TimeYear(Time[Past-1]); //    
   Total = (Past + Future) * (YearLeft - YearBegin +1);
   ArrayResize(gLenta, Total);
   
   i=0;
   int k=0, s=0;
   string LastDate;
   double Profit;
   //     1     !
   int YearCurrent = YearBegin-1, YearLast=0;
   for(int j = YearBegin; j <= YearLeft; j++){
      for(k = Past-1; k >= -Future; k--){
         if(k>=0){
            if(YearLast<TimeYear(Time[k])) {
               YearCurrent=YearCurrent+1;
               //Print(YearCurrent, "   ", k, " = ", TimeYear(Time[k]));
            }
            YearLast = TimeYear(Time[k]);
            LastDate = DoubleToStr(YearCurrent,0)+"."+DoubleToStr(TimeMonth(Time[k]),0)+"."+DoubleToStr(TimeDay(Time[k]),0)+
				             " "+DoubleToStr(TimeHour(Time[k]),0)+":"+DoubleToStr(TimeMinute(Time[k]),0);
		   }else{
		      if(YearLast<TimeYear(Time[0]-k*Period()*60)) {
		         YearCurrent=YearCurrent+1;
		         //Print(YearCurrent, "   ", k, " = ", TimeYear(Time[0]-k*Period()*60));
		      }
		      YearLast = TimeYear(Time[0]-k*Period()*60);
            LastDate = DoubleToStr(YearCurrent,0)+"."+DoubleToStr(TimeMonth(Time[0]-k*Period()*60),0)+"."+DoubleToStr(TimeDay(Time[0]-k*Period()*60),0)+
				             " "+DoubleToStr(TimeHour(Time[0]-k*Period()*60),0)+":"+DoubleToStr(TimeMinute(Time[0]-k*Period()*60),0);
		   }
		   
         for(s=0; s<ArraySize(gSymbol); s++){
            Profit = gVolume[s] * gK[s] * GetPrice(gSymbol[s], StrToTime(LastDate), indexPeriod);
            /*if(BaseSymbol>0 && BaseSymbol<=ArraySize(gSymbol) && MarketInfo(gSymbol[s], MODE_PROFITCALCMODE)==0){
               Profit = Profit / MarketInfo(gSymbol[s], MODE_POINT);
            }*/
            gLenta[i] = gLenta[i] + Profit;
         }//Next s
         if(BaseSymbol>0 && BaseSymbol<=ArraySize(gSymbol))
            gLenta[i] = GetTick(gSymbol[BaseSymbol-1], gLenta[i], gVolume[BaseSymbol-1],  gK[BaseSymbol-1]);
         i++;
      }//Next k
      YearCurrent = YearCurrent + (TimeYear(Time[Past-1]) - YearLast) + 1;
   }//Next j
   
   //Print(" ", i , " .  : ", Total);
   return(Total);
}//LentaInit()
//+----------------------------------------------------------------------------+
//|      :   (EvgeTrofi)                                   |
//+----------------------------------------------------------------------------+
//|     : 18.12.2012                                                     |
//|   :    Close   .   |
//|                 ,        |
//|                     .          |
//|                -  -1                               |
//|    inSymbol  -                                      |
//|    inDate    - ,                                         |
//|    inTimeFrame  -    ( 1  9)                   |
//+----------------------------------------------------------------------------+
double GetPrice(string inSymbol, datetime inDate, int inTimeFrame=1){
   double res=-1;
   datetime timeA, timeB;
   double priceC, priceD;
   int Candle=0;
   timeA = (inSymbol, inTimeFrame);
   if(timeA>inDate){
      Print("!      ",inSymbol,
      "  ", TimeToStr(inDate), "! ,    ", TimeToStr(timeA));
      return(-1);
   }
   Candle = iBarShift(inSymbol, mper[inTimeFrame], inDate);
   datetime ResultTime = iTime(inSymbol, mper[inTimeFrame], Candle);
   if(ResultTime>inDate){
      if(inTimeFrame == 9) return(-1);
      res = GetPrice(inSymbol, inDate, inTimeFrame+1);
   }else{
      
      timeA = ResultTime;
      priceC = iClose(inSymbol, mper[inTimeFrame], Candle);
      timeB = timeA;
      while(timeB==timeA && Candle>0){
         Candle--;
         timeB = iTime(inSymbol, mper[inTimeFrame], Candle);
      }
      if(timeB-timeA==0) return(priceC);
      priceD = iClose(inSymbol, mper[inTimeFrame], Candle);
      res = priceD - (timeB - inDate) * (priceD - priceC) / (timeB - timeA);
      
   }
   return(res);
}//GetPrice()
//+----------------------------------------------------------------------------+
datetime (string inSymbol, int inTimeFrame=1){
   datetime res=0, t=0;
   int Candle=0;
   for(int i = inTimeFrame; i<10; i++){
      Candle = iBars(inSymbol, mper[i]);
      t=iTime(inSymbol, mper[i], Candle-1);
      if(t<res || res==0){
         res=t;
//      }else{
//         break;
      }
   }
   return(res);
}//()
//+----------------------------------------------------------------------------+
int GetNumberTimeFrame(int inPeriod){
   for(int i = 8; i>=0; i--){
      if(inPeriod>mper[i]){
         return(i+1);
      }
   }
   return(0);
}//GetNumberTimeFrame()
//+----------------------------------------------------------------------------+
//|      :   (EvgeTrofi)                                   |
//+----------------------------------------------------------------------------+
//|     : 18.12.2012                                                     |
//|   :   IntervalBegin[], IntervalEnd[].              |
//|    inNum      -                                  |
//|    inInterval -                   |
//+----------------------------------------------------------------------------+
void IntervalInput(int inNum, string inInterval=""){
   if(StringLen(inInterval)==0) return;
   int pos = StringFind(inInterval, "-");
   if(pos>0){
      IntervalBegin[inNum-1] = Year() - MathAbs(StrToDouble(StringSubstr(inInterval, 0, pos)));
      IntervalEnd[inNum-1] = Year() - MathAbs(StrToDouble(StringSubstr(inInterval, pos+1)));
   }else{
      IntervalBegin[inNum-1] = Year() - MathAbs(StrToDouble(inInterval));
      IntervalEnd[inNum-1] = Year() - IntervalBegin[inNum-1];
   }
}//IntervalInput()
//+----------------------------------------------------------------------------+
//|      :   (EvgeTrofi)                                   |
//+----------------------------------------------------------------------------+
//|     : 17.12.2012                                                     |
//|   :   gSymbol  gVolume.                           |
//|                .               |
//+----------------------------------------------------------------------------+
int GlobalInit(){
   int Total=0, pos1=0, pos2=0;
   int pos=StringFind(Formula, "=");
   string sLeft = "", sRight = "";
   if(pos>0){//   
      sLeft = StringSubstr(Formula, 0, pos);
      sRight = StringSubstr(Formula, pos+1);
   }else{//   
      sLeft = Formula;
      sRight = "";
   }
   int length=StringLen(sLeft);
   while (pos2<length){
      Total++;
      ArrayResize(gSymbol,Total);
      ArrayResize(gVolume,Total+1);
      ArrayResize(gK, Total);
      int char=0;
      if(Total==1){
         char=StringGetChar(sLeft, 0);
         if(char==43){
            gVolume[0]=1;
            pos2++;
         }else if(char==45){
            gVolume[0]=-1;
            pos2++;
         }else{
            gVolume[0]=1;
         }
      }
      pos1=pos2;
      char=0;
      while (char!=43 && char!=45){ //    
         pos2++;
         char = StringGetChar(sLeft, pos2);
         if ((length-1)<pos2) break;
      }
      if(char==43){ //
         gVolume[Total]=1;
      }else if(char==45){ //
         gVolume[Total]=-1;
      }
      gSymbol[Total-1] = StringUpper(StringSubstr(sLeft, pos1, pos2-pos1));
      pos2++;
   }
   ArrayResize(gVolume, Total);
   if(StringLen(sRight)==0) return(Total);
   pos=0;
   pos1=0;
   pos2=StringFind(sRight, "^");
   while(pos2>=0){
      gVolume[pos] = gVolume[pos] * StrToDouble(StringSubstr(sRight, pos1, pos2-pos1));
      pos1 = pos2 + 1;
      pos2 = StringFind(sRight, "^", pos1);
      pos++;
   }
   gVolume[pos] = gVolume[pos] * StrToDouble(StringSubstr(sRight, pos1));
   return(Total);
}//GlobalInit()
//+----------------------------------------------------------------------------+
//     
string StringUpper(string s) {
  int c, i, k=StringLen(s), n;
  for (i=0; i<k; i++) {
    n=0;
    c=StringGetChar(s, i);
    if (c>96 && c<123) n=c-32;    // a-z -> A-Z
    if (c>223 && c<256) n=c-32;   // - -> -
    if (c==184) n=168;            //    ->  
    if (n>0) s=StringSetChar(s, i, n);
  }
  return(s);
}//StringUpper()
//+----------------------------------------------------------------------------+
void VisualJalousie(int inRows, int inColumns, int inSize=25, color inColor = White){
   // 
   string JName;
   int hwnd = WindowFind(IndicatorName);  
   for(int i=0; i<inRows; i++){
      for(int j=0; j<inColumns; j++){
         JName = "jalousie"+i+j;
         ObjectCreate(JName, OBJ_LABEL, hwnd, 0, 0);
         ObjectSet(JName, OBJPROP_CORNER, 0);
         ObjectSet(JName, OBJPROP_XDISTANCE, 0.6*inSize*j);
         ObjectSet(JName, OBJPROP_YDISTANCE, 8+0.6*inSize*i);
         ObjectSet(JName, OBJPROP_BACK, 0);
         ObjectSet(JName, OBJPROP_COLOR, inColor);
         ObjectSetText(JName, "n", inSize, "Wingdings");
      }
   }   
}//VisualJalousie()
//+----------------------------------------------------------------------------+
void VisualJalousieDelete(){
   string JName;
   for(int i=0; i<100; i++){
      for(int j=0; j<100; j++){
         JName = "jalousie"+i+j;
         if(ObjectFind(JName)>-1) ObjectDelete(JName);
      }
   }      
}//VisualJalousie()